package com.fp.persistence.pgeneral.vault;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import java.math.BigDecimal;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENEVAULT*/
@Entity(name="TgeneVault")
@Table(name="TGENEVAULT")
public class TgeneVault extends com.fp.dto.AbstractDataBalanceTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TgeneVault
*/
@EmbeddedId
private TgeneVaultKey pk;
@Column(name="BALANCE", nullable=true)

/**
* Saldo de boveda
*/
private BigDecimal balance;

/**Contructor por defecto*/
public TgeneVault(){
}
/**Contructor de TgeneVault
@param pPk Clave Primaria del entity
*/
public TgeneVault(TgeneVaultKey pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TgeneVault
*/
public static TgeneVault find(EntityManager pEntityManager,TgeneVaultKey pKey) throws Exception{
    TgeneVault obj = pEntityManager.find(TgeneVault.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TgeneVault
@return El objeto que referencia a la Clave primaria de TgeneVault
*/
public TgeneVaultKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TgeneVault
@param pPk El objeto que referencia a la nueva Clave primaria de TgeneVault
*/
public void setPk(TgeneVaultKey pPk){
  pk=pPk;
}
/**Obtiene el valor de balance
@return valor de balance*/
public BigDecimal getBalance(){
  return balance;
}
/**Fija el valor de balance
@param pBalance nuevo Valor de balance*/
public void setBalance(BigDecimal pBalance){
  balance=pBalance;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TgeneVault))return false;
    TgeneVault that = (TgeneVault) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TgeneVault
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TgeneVault
*/
public Object createInstance(){
 TgeneVault instance=new TgeneVault();	
 instance.setPk(new TgeneVaultKey());
 return instance;
}
/**Clona la entidad TgeneVault
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TgeneVault p=(TgeneVault)this.clone();
  p.setPk((TgeneVaultKey)this.pk.cloneMe());
  return p;
}
}
